﻿Minutiae = LibStub("AceAddon-3.0"):NewAddon("Minutiae", "AceConsole-3.0", "AceEvent-3.0")
local MinutiaeVersion = "2.0 RC3"
local LDB = LibStub("LibDataBroker-1.1", true)
local LDBIcon = LDB and LibStub("LibDBIcon-1.0", true)

function Minutiae:OnInitialize()
	self.db = LibStub("AceDB-3.0"):New("MinutiaeDB", {
	global = {
		minimap = {hide = false},
        repTracking = true,
		repair = true,
		repairselfless = false,
		release = true,
		sell = true,
		resurrect = false,
		summon = false,
		questAccept = true,
        questTurnin = true,
        lowLevel = false,
        repeatable = false,
		invite = true,
		duel = false,
		startup = true,
        label = "",
        showInChat = true,
		dynamic = true,
		sticky = true,
		decrease = false,
		trackTabard = false,
		guild = true,
		defaultGuild = true,
        ZoneToFaction = {}
		},
	})
	self:RegisterChatCommand("Minutiae", "ChatCommand")
	MinutiaeLauncher = LDB:NewDataObject("Minutiae", {
		type = "launcher",
		icon = "Interface\\Icons\\Inv_misc_archstone_01.png",
		OnClick = function(_, button)
			if button == "RightButton" then
				InterfaceOptionsFrame_OpenToCategory(Minutiae.optionsFrame)
			end
		end,
		OnTooltipShow = function(tt)
			tt:AddLine("|cFFFF0000Minutiae "..MinutiaeVersion)
			tt:AddLine("|cFFFF8080Right Click|cFFFFFFFF to display the options panel")
		end})
	LDBIcon:Register("Minutiae", MinutiaeLauncher, self.db.global.minimap)
end

function Minutiae:OnEnable()
	MinutiaeOptions = {
	name = "Minutiae",
	handler = Minutiae,
	type = "group",
	childGroups = "tab",
	args = {
		vendor = {
			name = "Vendor",
			handler = Minutiae,
			order = 1,
			type = 'group',
			args = {
				repair = {
					order = 1,
					type = 'toggle',
					name = 'Repair',
					desc = 'When checked, Minutiae attempts to repair all equipment at any vendor capable of repairing.  Will try guild repairs before personal funds.',
					get = 'Is',
					set = 'Set'
				},
				repairDesc = {
					order = 2,
					type = 'description',
					name = 'When checked, Minutiae attempts to repair all equipment at any vendor capable of repairing.  Will try guild repairs before personal funds.'
				},
				repairSelfless = {
					order = 3,
					type = 'toggle',
					name = 'Use Personal Funds',
					desc = 'When checked, Minutiae will always use personal funds to repair, not guild funds.',
					get = 'Is',
					set = 'Set',
					disabled = function() return not self.db.global.repair end
				},
				repairSelflessDesc = {
					order = 4,
					type = 'description',
					name = 'When checked, Minutiae will always use personal funds to repair, not guild funds.'
				},
				sell = {
					order = 5,
					type = 'toggle',
					name = 'Sell Grey Items',
					desc = 'When checked, Minutiae will automatically sell grey (junk) quality items.',
					get = 'Is',
					set = 'Set'
				},
				sellDesc = {
					order = 6,
					type = 'description',
					name = 'When checked, Minutiae will automatically sell grey (junk) quality items.'
				},
			}
		},
		combat = {
			name = "Combat",
			handler = Minutiae,
			order = 2,
			type = 'group',
			args = {	
				release = {
					order = 1,
					type = 'toggle',
					name = 'Release in BGs',
					desc = 'When checked, Minutiae automatically releases your spirit upon death in a battleground.',
					get = 'Is',
					set = 'Set'
				},
				releaseDesc = {
					order = 2,
					type = 'description',
					name = 'When checked, Minutiae automatically releases your spirit upon death in a battleground.'
				},
				resurrect = {
					order = 3,
					type = 'toggle',
					name = 'Accept Resurrects',
					desc = 'When checked, Minutiae will automatically accept resurrects.',
					get = 'Is',
					set = 'Set'
				},
				resurrectDesc = {
					order = 4,
					type = 'description',
					name = 'When checked, Minutiae will automatically accept resurrects.'
				},
			}
		},
		dialogs = {
			name = "Invites",
			handler = Minutiae,
			order = 3,
			type = 'group',
			args = {
				duel = {
					order = 1,
					type = 'toggle',
					name = 'Decline Duels',
					desc = 'When checked, Minutiae will automatically decline any duel request.',
					get = 'Is',
					set = 'Set'
				},
				duelDesc = {
					order = 2,
					type = 'description',
					name = 'When checked, Minutiae will automatically decline any duel request.'
				},
				invite = {
					order = 3,
					type = 'toggle',
					name = 'Accept Invites',
					desc = 'When checked, Minutiae will automatically accept group invites from friends and guild members.',
					get = 'Is',
					set = 'Set'
				},
				inviteDesc = {
					order = 4,
					type = 'description',
					name = 'When checked, Minutiae will automatically accept group invites from friends and guild members.'
				},
				summon = {
					order = 5,
					type = 'toggle',
					name = 'Accept Summons',
					desc = 'When checked, Minutiae will automatically accept summons.',
					get = 'Is',
					set = 'Set'
				},
				summonDesc = {
					order = 6,
					type = 'description',
					name = 'When checked, Minutiae will automatically accept summons.'
				}
			}
		},
        quests = {
            name = 'Quests',
            handler = Minutiae,
            order = 4,
            type = 'group',
            args = {
				questAccept = {
					order = 1,
					type = 'toggle',
					name = 'Accept Quests',
					desc = 'When checked, Minutiae will automatically accept quests.',
					get = 'Is',
					set = 'Set'
				},
				questAcceptDesc = {
					order = 2,
					type = 'description',
					name = 'When checked, Minutiae will automatically accept quests.  Holding shift will temporarily disable this feature.'
				},
                questTurnin = {
                    order = 3,
					type = 'toggle',
					name = 'Turn In Quests',
					desc = 'When checked, Minutiae will automatically turn in quests.',
					get = 'Is',
					set = 'Set'
                },
                questTurninDesc = {
                    order = 4,
					type = 'description',
					name = 'When checked, Minutiae will automatically turn in quests.  Holding shift will temporarily disable this feature.'
                },
                lowLevel = {
                    order = 5,
                    type = 'toggle',
                    name = 'Low Level Quests',
                    desc = 'When checked, Minutiae will also accept low level quests.',
                    get = 'Is',
                    set = 'Set',
                    disabled = function() return not self.db.global.questAccept end
                },
                lowLevelDesc = {
                    order = 6,
                    type = 'description',
                    name = 'When checked, Minutiae will also accept low level quests.'
                },
                repeatable = {
                    order = 7,
                    type = 'toggle',
                    name = 'Repeatable Quests',
                    desc = 'When checked, Minutiae will also accept repeatable quests.',
                    get = 'Is',
                    set = 'Set',
                    disabled = function() return not self.db.global.questAccept end
                },
                repeatableDesc = {
                    order = 8,
                    type = 'description',
                    name = 'When checked, Minutiae will also accept repeatable quests.'
                }
            }
        },
		reputation = {
			name = "Reputation",
			handler = Minutiae,
			order = 5,
			type = 'group',
			args = {
				trackingType = {
                    order = 1,
                    type = 'select',
                    style = 'radio',
                    name = 'Type of Reputation Tracking:',
                    values = {
                        "Dynamic",
                        "Tabard",
                        "None"
                    },
                    get = 'ReturnLabel',
                    set = 'SetLabel'
                },
				trackDesc1 = {
					order = 2,
					type = 'description',
					name = 'Dynamic Tracking - Reputation gains also changed the watched faction.'
				},
                trackDesc2 = {
					order = 3,
					type = 'description',
					name = 'Tabard Tracking - Just track the reputation of the faction whose tabard you wear.'
				},
                trackDesc3 = {
					order = 4,
					type = 'description',
					name = 'None - Turn off reputation tracking.'
				},
				sticky = {
					order = 5,
					type = 'toggle',
					name = 'Sticky Rep',
					desc = 'Dynamic tracking changes are permanently stored as the default tracked faction for that zone.',
					get = "Is",
					set = "Toggle"
				},
				stickyDesc = {
					order = 6,
					type = 'description',
					name = 'Dynamic tracking changes are permanently stored as the default tracked faction.'
				},
				decrease = {
					order = 7,
					type = 'toggle',
					name = 'Track Decreases',
					desc = 'Track reputation decreases.',
					get = "Is",
					set = "Toggle"
				},
				decreaseDesc = {
					order = 8,
					type = 'description',
					name = 'Track reputation decreases.'
				},
	        	guild = {
					order = 9,
					type = 'toggle',
					name = 'Track Guild Reputation',
					desc = 'Track Guild reputation changes',
					get = "Is",
					set = "Toggle"
			        },
        		guildDesc = {
					order = 10,
					type = 'description',
					name = 'Includes changes to guild reputation in tracking.'
			        },
        		defaultGuild = {
					order = 11,
					type = 'toggle',
					name = 'Default to Guild',
					desc = 'Tracks Guild reputation when entering a zone that does not yet have a faction assigned.',
					get = "Is",
					set = "Toggle"
				},
				defaultGuildDesc = {
					order = 12,
					type = 'description',
					name = 'Tracks Guild reputation when entering a zone that does not yet have a faction assigned.'
				},
				showInChat = {
					order = 13,
					type = 'toggle',
					name = 'Show In Chat',
					desc = 'Display MinutiaeRep messages in the chat window.',
					get = "Is",
					set = "Toggle"
				},
				showInChatDesc = {
					order = 14,
					type = 'description',
					name = 'Display MinutiaeRep messages in the chat window.'
				}
			}
		},	
        misc = {
			name = "Miscellaneous",
			handler = Minutiae,
			order = 6,
			type = "group",
			args = {
                ldbText = {
                    order = 1,
                    type = 'select',
                    style = 'radio',
                    name = 'LDB Label:',
                    values = {
                        "Reputation Tracking",
                        "Durability Percentage"
                    },
                    get = 'ReturnLabel',
                    set = 'SetLabel'
                },
				minimap = {
					order = 2,
					type = 'toggle',
					name = 'Show Minimap Button',
					desc = 'Show the Minimap Button',
					get = 'Is',
					set = 'Set'
				},
				startup = {
					order = 3,
					type = 'toggle',
					name = 'Show Version Loaded',
					desc = 'Show the one-line startup text that displays Minutiae version loaded.',
					get = 'Is',
					set = 'Set'
				},
				aboutHeader = {
					order = 4,
					type = 'header',
					name = 'About'
				},
				version = {
					order = 5,
					type = 'description',
					name = "Version: |cFFFF0000"..MinutiaeVersion.."|r"
				},
				author = {
					order = 6,
					type = 'description',
					name = 'by |cFFFF0000InSo(v)nIaX|r'
				}
			}
		}
	}}
	LibStub("AceConfig-3.0"):RegisterOptionsTable("Minutiae", MinutiaeOptions)
	self.optionsFrame = LibStub("AceConfigDialog-3.0"):AddToBlizOptions("Minutiae")
	if self.db.global.startup then
		print("|cFFFF0000Minutiae|r: v"..MinutiaeVersion.." Loaded.")
	end
    self:ChangeLabel()
    if self.db.global.label == "durability" then
        self:RegisterEvent("UPDATE_INVENTORY_DURABILITY")
    end
end

function Minutiae:SetLabel(option, selection)
    if selection == 1 then
        if option[1] == "misc" then
            self.db.global.label = "reputation"
            self:UnregisterEvent("UPDATE_INVENTORY_DURABILITY")
            self:RegisterEvent("UPDATE_FACTION")
        elseif option[1] == "reputation" then
            self.db.global.dynamic = true
            self.db.global.repTracking = true
            self.db.global.trackTabard = false
        end
    elseif selection == 2 then
        if option[1] == "misc" then
            self.db.global.label = "durability"
            self:UnregisterEvent("UPDATE_FACTION")
            self:RegisterEvent("UPDATE_INVENTORY_DURABILITY")
        elseif option[1] == "reputation" then
            self.db.global.dynamic = false
            self.db.global.repTracking = true
            self.db.global.trackTabard = true
        end
    elseif selection == 3 then
        if option[1] == "reputation" then
            self.db.global.dynamic = false
            self.db.global.repTracking = false
            self.db.global.trackTabard = false
        end
    end
    self:ChangeLabel()
end

function Minutiae:UPDATE_INVENTORY_DURABILITY()
    self:ChangeLabel()
end

function Minutiae:UPDATE_FACTION()
    self:ChangeLabel()
end

hooksecurefunc("MainMenuBar_UpdateExperienceBars", function()
    if not MinutiaeDB.global.label == "reputation" then
        return
    end
    Minutiae:ChangeLabel()
end)

function Minutiae:Toggle(info, value)
    self.db.global[info[2]] = value
	if info[2] == "dynamic" and self.db.global.dynamic then
		self:RegisterEvent("COMBAT_TEXT_UPDATE")
	elseif info[2] == "dynamic" then
		self:UnregisterEvent("COMBAT_TEXT_UPDATE")
	elseif info[2] == "trackTabard" and self.db.global.trackTabard then
		MinutiaeRep:UnregisterEvent("ZONE_CHANGED_NEW_AREA")
		self:UnregisterEvent("COMBAT_TEXT_UPDATE")
		self:RegisterEvent("PLAYER_EQUIPMENT_CHANGED")
		self:TabardCheck()
	elseif info[2] == "trackTabard" then
		MinutiaeRep:RegisterEvent("ZONE_CHANGED_NEW_AREA")
		self:UnregisterEvent("PLAYER_EQUIPMENT_CHANGED")
		if self.db.global.dynamic then
			self:RegisterEvent("COMBAT_TEXT_UPDATE")
		end
	end
end

function Minutiae:ChangeLabel()
    if self.db.global.label == "reputation" then
        local currentFaction, currentLevel, minRep, maxRep, currentRep = GetWatchedFactionInfo()
        local correction = 0
        local currentStatus = "Neutral"
        if currentLevel == 1 then
            correction = -42000
            currentStatus = "Hated"
            else if currentLevel == 2 then
                correction = -6000
                currentStatus = "Hostile"
                else if currentLevel == 3 then
                    correction = -3000
                    currentStatus = "Unfriendly"
                    else if currentLevel == 5 then
                        correction = 3000
                        currentStatus = "Friendly"
                    else if currentLevel == 6 then
                            correction = 9000
                            currentStatus = "Honored"
                        else if currentLevel == 7 then
                                correction = 21000
                                currentStatus = "Revered"
                            else if currentLevel == 8 then
                                    correction = 42000
                                    currentStatus = "Exalted"
                                end
                            end
                        end
                    end
                end
            end
        end
        if currentFaction then
            MinutiaeLauncher.text = currentFaction..": "..(currentRep-correction).."/"..(maxRep-correction).." ("..currentStatus..")"
        else
            MinutiaeLauncher.text = "No Reputation Watched"
        end
    end
    if self.db.global.label == "durability" then
        local currentDurability = 0
        local maxDurability = 0
        for i=19,1,-1 do
            local itemCurrent, itemMax = GetInventoryItemDurability(i)
            if itemMax then
                currentDurability = currentDurability + itemCurrent
                maxDurability = maxDurability + itemMax
            end
        end
        MinutiaeLauncher.text = math.floor(100*(currentDurability/maxDurability)+.005).."%"
    end
end

function Minutiae:ReturnLabel(option, selection)
    if option[1] == "misc" then
        if self.db.global.label == "reputation" then
            return 1
        elseif self.db.global.label == "durability" then
            return 2
        end
    elseif option[1] == "reputation" then
        if self.db.global.dynamic then
            return 1
        elseif self.db.global.trackTabard then
            return 2
        elseif not self.db.global.repTracking then
            return 3
        end
    end
end

function Minutiae:Set(arg, value)
	if arg[2] == "minimap" then
		self.db.global.minimap.hide = not value
		if self.db.global.minimap.hide then
			LDBIcon:Hide("Minutiae")
		else
			LDBIcon:Show("Minutiae")
		end
		return
	else
		self.db.global[arg[2]] = value
        if arg[2] == "quest" or arg[2] == "bind" or arg[2] == "gossip" or arg[2] == "invite" or arg[2] == "quest" or arg[2] == "release" or arg[2] == "repair" or arg[2] == "repTracking" or arg[2] == "resurrect" or arg[2] == "sell" or arg[2] == "summon" then
		    local module = "Minutiae"..arg[2]:gsub("^%l", string.upper)
		    if self.db.global[arg[2]] then
			    _G[module]:Enable()
		    else
			    _G[module]:Disable()
		    end
        end
	end
end

function Minutiae:Is(arg)
	if arg[2] == "minimap" then
		return not self.db.global.minimap.hide
	else
		return self.db.global[arg[2]]
	end
end

function Minutiae:ChatCommand(input)
	if not input or input:trim() == "" or input == "options" then
		InterfaceOptionsFrame_OpenToCategory(self.optionsFrame)
	else
		LibStub("AceConfigCmd-3.0").HandleCommand(Minutiae, "Minutiae", input)
	end
end

function Minutiae:ChangeBar(_, faction)
	if faction == nil then
		if self.db.global.showInChat and self.db.global.ZoneToFaction[GetZoneText()] ~= nil then
			print("|cFFFF0000Minutiae|r: Not tracking a reputation")
		end
		SetWatchedFactionIndex(0)
		self.db.global.ZoneToFaction[GetZoneText()] = nil
		return
	end
	MinutiaeRep:ScanFactions()
	if GetWatchedFactionInfo() then
		oldName = strlower(GetWatchedFactionInfo())
	end
	if strlower(faction) == "guild" and self.db.global.guild then
		if select(1,GetWatchedFactionInfo()) ~= select(1,GetGuildInfo("player")) then
			SetWatchedFactionIndex(2)
			if self.db.global.showInChat then
				print("|cFFFF0000Minutiae|r: "..select(1,GetGuildInfo("player")).." reputation tracked")
			end
	    end
		if self.db.global.sticky then
			self.db.global.ZoneToFaction[GetZoneText()] = "guild"
		end
		return
	end
	for i=1, GetNumFactions() do
		local name = strlower(GetFactionInfo(i))
		if name == strlower(faction) and name ~= oldName and name ~= "alliance" and name ~= "horde" and name ~= "guild" then
			SetWatchedFactionIndex(i)
			if self.db.global.showInChat then
				if self.db.global.trackTabard then
					print("|cFFFF0000Minutiae|r: "..faction.." reputation tracked")
				else
					print("|cFFFF0000Minutiae|r: "..GetZoneText()..": "..faction.." reputation tracked")
				end
			end
			if self.db.global.sticky then
				self.db.global.ZoneToFaction[GetZoneText()] = string.lower(faction)
			end
			return
		end
	end
end

function Minutiae:GetZone()
	if self.db.global.ZoneToFaction[GetZoneText()] == "guild" then
		return select(1,GetGuildInfo("player"))
	else
		return self.db.global.ZoneToFaction[GetZoneText()]
	end
end